from logging import getLogger
LOG = getLogger('SendfilePatch')

HasSendfilePatch = False

try:
	from sendfile import *
	LOG.info('Installing Sendfile Patch')
	from ZPublisher import HTTPResponse

	# We should provide a sendfilename option, but, by default
	# that opens a rather large can of worms.
	def patch_sendfile(self, file, content_type = '', other_headers = {}):
		fin = file.fileno()

		# Find out how many bytes to send...
		size = 0
		position = file.tell()
		file.seek(0, 2)
		size = file.tell() - position
		file.seek(position, 0)

		fout = self.stdout._channel.fileno()
		offset = 0
		self.setStatus(200)
		self.setHeader('content-length', size)
		if content_type:
			self.setHeader('Content-Type', content_type)

		for k, v in other_headers.items():
			self.setHeader(k, v)

		# Send the data.
		self._streaming = 1
		headers = str(self)
		self.stdout._channel.send(str(self))
		self._wrote = 1

		try:
			while size > 0:
				try:
					fp, sent = sendfile(fout, fin, offset, size)
					offset += sent
					size -= sent
				except OSError, (errn, msg):
					if errn == 11:
						pass
					else:
						raise
						
		except:
			LOG.info('sending file failed', exc_info = True)
			raise

		# I'm unsure if this is actually needed.
		self.stdout._bytes = size

	HTTPResponse.HTTPResponse.sendfile = patch_sendfile
	HasSendfilePatch = True
except:
	LOG.info('Sendfile patch failed')
	LOG.info('Did you install the sendfile module from http://tautology.org/software/python-modules/sendfile')

